

% demo_filter.m

%% load data
load('amplitude_room.mat');
load('depth_room.mat');

%% specify filter parameters
n = 9; % size of filtermask nxn (should be an odd number)
start_width = 0.1; % minimum kernel width (should be smaller than 1)
max_width = n/3; % max. kernel width (should be smaller than n/2)
width_step = 0.05; %increment (this has a big influence on runtime;
% don't make this too low)
var_thresh = 0.02; % target variance of denoised pixels

%% run the denoising filter
depth_new = adfilterNormConvWithConfMeasure(depth,amp.^2, n, var_thresh,...
    start_width, width_step, max_width);

%% visualize results
range = [1 6];

figure(1);
subplot(2,3,1)
imagesc (depth,range);
title('Original 3D map [m]');
colorbar('SouthOutside');
subplot(2,3,2)
imagesc (depth_new,range);
title('Denoised 3D map [m]');
colorbar('SouthOutside');
subplot(2,3,3)
imagesc (depth_new-depth);
title('Difference [m]');
colorbar('SouthOutside');
subplot(2,3,4)
imagesc (amp);
title('Amplitude of IR-Modulation');
colorbar('SouthOutside');
subplot(2,3,5)
imagesc (1./(amp.^2));
title('Inverse Squared Amplitude (=Filter Strength)');
colorbar('SouthOutside');

colormap(gray);

